<#	
	.NOTES
	===========================================================================
	 Created with: 	SAPIEN Technologies, Inc., PowerShell Studio 2015 v4.2.85
	 Created on:   	8/6/2015 2:27 PM
	 Created by:   	Ben Miller
	 Organization: 	
	 Filename:     	Load-SqlAssemblies.ps1
	===========================================================================
     Written by Ben Miller, PowerShellDBA.com
     
     (c) 2016, PowerShellDBA.com. All rights reserved.
     
     For more scripts and sample code, check out 
     http://PowerShellDBA.com
     
     You may alter this code for your own *non-commercial* purposes. You may
     republish altered code as long as you include this copyright and give due
     credit, but you must obtain prior permission before blogging this code.
     
     THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
     ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
     TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
     PARTICULAR PURPOSE.
	===========================================================================
	.DESCRIPTION
		A description of the file.
#>

function Load-SqlAssemblies
{
	param (
		[ValidateSet(10, 11, 12, 13)]
		$Version,
		[switch]$All,
		[switch]$SQLPS,
		[switch]$Basic = $true,
		[switch]$x86,
		[String[]]$AssemblyList
	)
	
	if ($SQLPS.IsPresent)
	{
		$modlist = Get-Module -ListAvailable -Name SQLPS
		foreach ($mod in $modlist)
		{
			if ($mod.ModuleBase -match "\\$($Version)0\\")
			{
				if (!$x86.IsPresent)
				{
					if (!($mod.ModuleBase -match "(x86)"))
					{
						Import-Module $mod.ModuleBase -DisableNameChecking
						break
					}
				}
				else
				{
					if ($mod.ModuleBase -match "(x86)")
					{
						Import-Module $mod.ModuleBase -DisableNameChecking
						break
					}	
				}
			}
		}
	}
	elseif ($All.IsPresent)
	{
		$list = "Microsoft.SqlServer.ConnectionInfo, Version=$Version.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91", `
		"Microsoft.SqlServer.Dmf, Version=$Version.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91", `
		"Microsoft.SqlServer.Management.Collector, Version=$Version.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91", `
		"Microsoft.SqlServer.Management.CollectorEnum, Version=$Version.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91", `
		"Microsoft.SqlServer.Management.HadrDMF, Version=$Version.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91", `
		"Microsoft.SqlServer.Management.RegisteredServers, Version=$Version.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91", `
		"Microsoft.SqlServer.Management.Sdk.Sfc, Version=$Version.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91", `
		"Microsoft.SqlServer.Management.Utility, Version=$Version.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91", `
		"Microsoft.SqlServer.Management.UtilityEnum, Version=$Version.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91", `
		"Microsoft.SqlServer.RegSvrEnum, Version=$Version.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91", `
		"Microsoft.SqlServer.ServiceBrokerEnum, Version=$Version.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91", `
		"Microsoft.SqlServer.Smo, Version=$Version.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91", `
		"Microsoft.SqlServer.SmoExtended, Version=$Version.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91", `
		"Microsoft.SqlServer.SqlClrProvider, Version=$Version.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91", `
		"Microsoft.SqlServer.SqlEnum, Version=$Version.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91", `
		"Microsoft.SqlServer.SqlWmiManagement, Version=$Version.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91", `
		"Microsoft.SqlServer.WmiEnum, Version=$Version.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91"
		
		foreach ($mod in $list)
		{
			Add-Type -AssemblyName $mod
		}
	}
	elseif ($Basic.IsPresent)
	{
		$list = "Microsoft.SqlServer.ConnectionInfo, Version=$Version.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91", `
		"Microsoft.SqlServer.Smo, Version=$Version.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91", `
		"Microsoft.SqlServer.SmoExtended, Version=$Version.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91", `
		"Microsoft.SqlServer.SqlEnum, Version=$Version.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91"
		
		foreach ($mod in $list)
		{
			Add-Type -AssemblyName $mod
		}
	}
	
	if ($AssemblyList.Length -gt 0)
	{
		foreach ($mod in $AssemblyList)
		{
			Add-Type -AssemblyName "$mod, Version=$Version.0.0.0, Culture=neutral, PublicKeyToken=89845dcd8080cc91"
		}
	}
}
