# Set-SqlConfig.ps1
# Changes Server Configuration parameters from installation defaults
# Credit goes to Allen White for this script, he is the author

$s = new-object -TypeName Microsoft.SqlServer.Management.Smo.Server -Args WIN2012CORE

# Show Advanced Options
$s.Configuration.ShowAdvancedOptions.ConfigValue = 1

# Enable Database Mail
$s.Configuration.DatabaseMailEnabled.ConfigValue = 1

# Enable CLR Procedures
$s.Configuration.IsSqlClrEnabled.ConfigValue = 1

# Set Max DOP to Single Processor Mode
$s.Configuration.MaxDegreeOfParallelism.ConfigValue = 1

# Set Backup Compression On
if ($s.Information.EngineEdition -eq 'EnterpriseOrDeveloper') {
	$s.Configuration.DefaultBackupCompression.ConfigValue = 1
	}

# Make the changes
$s.Configuration.Alter($true)